<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'record_eodct_payrep');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_REC_EODPAYCT_ID',
							'PARAM_REC_EODPAYCT_REC_EODREP_ID', 
							'PARAM_REC_EODPAYCT_TRANSACTION', 
							'PARAM_REC_EODPAYCT_PAID_CASH', 
							'PARAM_REC_EODPAYCT_PAID_CARD', 
							'PARAM_REC_EODPAYCT_PAID_CHECK', 
							'PARAM_REC_EODPAYCT_PAID_BANK', 
							'PARAM_REC_EODPAYCT_PAID_LOYALTY', 
							'PARAM_REC_EODPAYCT_PAID_VOUCHER', 
							'PARAM_REC_EODPAYCT_PAID_OTHER', 
							'PARAM_REC_EODPAYCT_STATUS'
							// , 'PARAM_REC_EODPAYCT_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_EODPAYCT_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAYCT_ID', true);
			$PARAM_REC_EODPAYCT_REC_EODREP_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAYCT_REC_EODREP_ID', true);
			$PARAM_REC_EODPAYCT_TRANSACTION = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_EODPAYCT_TRANSACTION', true);
			$PARAM_REC_EODPAYCT_PAID_CASH = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_CASH', true);
			$PARAM_REC_EODPAYCT_PAID_CARD = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_CARD', true);
			$PARAM_REC_EODPAYCT_PAID_CHECK = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_CHECK', true);
			$PARAM_REC_EODPAYCT_PAID_BANK = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_BANK', true);
			$PARAM_REC_EODPAYCT_PAID_LOYALTY = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_LOYALTY', true);
			$PARAM_REC_EODPAYCT_PAID_VOUCHER = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_VOUCHER', true);
			$PARAM_REC_EODPAYCT_PAID_OTHER = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_EODPAYCT_PAID_OTHER', true);
			$PARAM_REC_EODPAYCT_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_EODPAYCT_STATUS', true);
			
			//$PARAM_REC_EODPAYCT_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_REC_EODPAYCT_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_REC_EODPAYCT_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_REC_EODPAYCT_ID,
							$PARAM_REC_EODPAYCT_REC_EODREP_ID, 
							$PARAM_REC_EODPAYCT_TRANSACTION, 
							$PARAM_REC_EODPAYCT_PAID_CASH, 
							$PARAM_REC_EODPAYCT_PAID_CARD, 
							$PARAM_REC_EODPAYCT_PAID_CHECK, 
							$PARAM_REC_EODPAYCT_PAID_BANK, 
							$PARAM_REC_EODPAYCT_PAID_LOYALTY, 
							$PARAM_REC_EODPAYCT_PAID_VOUCHER, 
							$PARAM_REC_EODPAYCT_PAID_OTHER, 
							$PARAM_REC_EODPAYCT_STATUS
							// ,$PARAM_REC_EODPAYCT_ID_FILE['name']
					]
			);
			
				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_RECORD_EODCT_PAYREP::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_ID'] = $PARAM_REC_EODPAYCT_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_REC_EODREP_ID'] = $PARAM_REC_EODPAYCT_REC_EODREP_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_TRANSACTION'] = $PARAM_REC_EODPAYCT_TRANSACTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_CASH'] = $PARAM_REC_EODPAYCT_PAID_CASH[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_CARD'] = $PARAM_REC_EODPAYCT_PAID_CARD[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_CHECK'] = $PARAM_REC_EODPAYCT_PAID_CHECK[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_BANK'] = $PARAM_REC_EODPAYCT_PAID_BANK[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_LOYALTY'] = $PARAM_REC_EODPAYCT_PAID_LOYALTY[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_VOUCHER'] = $PARAM_REC_EODPAYCT_PAID_VOUCHER[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_PAID_OTHER'] = $PARAM_REC_EODPAYCT_PAID_OTHER[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_EODPAYCT_STATUS'] = $PARAM_REC_EODPAYCT_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_RECORD_EODCT_PAYREP::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_FILEDIR_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/eodct_payrep');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Record/eodct_payrep/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000));
					
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_REC_EODPAYCT_ID_FILE['tmp_name'][$ARRAY_CTR],
							PHPSET::$ROOT . '/upload/priv/Record/eodct_payrep/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000) . '/' . $DATA_SET[0]['INSERTED_ID'] . '.' .
							PHPVC_STR::VAR_LCASE(PathInfo($PARAM_REC_EODPAYCT_ID_FILE['name'][$ARRAY_CTR], PATHINFO_EXTENSION))
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>